/*
 * Copyright (C) 2010 Teleal GmbH, Switzerland
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.teleal.cling.support.connectionmanager;

import java.util.logging.Logger;
import org.teleal.cling.controlpoint.ActionCallback;
import org.teleal.cling.model.action.ActionArgumentValue;
import org.teleal.cling.model.action.ActionException;
import org.teleal.cling.model.action.ActionInvocation;
import org.teleal.cling.model.meta.Service;
import org.teleal.cling.model.message.UpnpResponse;
import org.teleal.cling.model.types.ErrorCode;
import org.teleal.cling.support.connectionmanager.protocolinfo.ProtocolInfo;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 *
 * @author Christian Bauer
 */
public abstract class GetProtocolInfoActionCallback extends ActionCallback {

    private static Logger log = Logger.getLogger(GetProtocolInfoActionCallback.class.getName());

    public GetProtocolInfoActionCallback(Service service) {
        super(new ActionInvocation(service.getAction("GetProtocolInfo")));
    }

    public void success(ActionInvocation invocation) {

        String sinkProtocolInfo = invocation.getOutput("Sink").toString();

        if (sinkProtocolInfo.length() > 0) {
            try {

                List<ProtocolInfo> protocolInfos = new ArrayList();
                String[] split = sinkProtocolInfo.split(",");
                for (String s : split) {
                    protocolInfos.add(ProtocolInfo.fromString(s));
                }

                received(invocation, protocolInfos);

            } catch (Exception ex) {
                invocation.setFailure(
                        new ActionException(ErrorCode.ACTION_FAILED, "Can't parse ProtocolInfo response: " + ex, ex)
                );
                failure(invocation, null);
            }
        } else {
            received(invocation, Collections.EMPTY_LIST);
        }
    }

    public void failure(ActionInvocation invocation, UpnpResponse operation) {
        failure(createDefaultFailureMessage(invocation, operation));
    }

    public abstract void received(ActionInvocation actionInvocation, List<ProtocolInfo> sinkProtocolInfos);
    public abstract void failure(String failureMessage);

}